/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "item.h"
#include "misc.h"



Item::Item()
{
	Clear();
}


void Item::SetDateToNow()
{
	date_creation     = Time(std::time(0));
	date_modification = date_creation;
}


void Item::SetDateModifyToNow()
{
	date_modification = Time(std::time(0));
}


void Item::Clear()
{
	id = -1;
	
	user_id = -1;
	group_id = -1;
	privileges = 0;
	modification_user_id = -1;

	guest_name.clear();
	
	subject.clear();
	content.clear();
	url.clear();	
	
	content_type = ct_formatted_text;
	
	type = none;
	parent_id = -1;
	default_item = -1;

	content_id = -1;

	auth = auth_none;
	auth_path.clear();

	html_template.clear();

	SetDateToNow();
}
