/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucoresession
#define headerfilecmslucoresession

#include <ctime>
#include "item.h"
#include "error.h"
#include "user.h"
#include "plugindata.h"
#include "rebus.h"


struct Session
{
	// 0 - means that there is no session
	long id;
	
	// true if the session was created now
	bool new_session;

	// when this session was created
	// (the same values)
	time_t time;
	tm tm_time;
	
	// when this session was last used
	// (the same values)
	time_t last_time;
	tm tm_last_time;

	// when there was a last get request
	// (used to calculate spam)
	time_t last_time_get;
	
	// 0 - means that nobody is logged	
	User * puser;

	// if false the session will end when the user browser is shutdown
	bool remember_me;


	// rebus - set by rebus_question(Info & i) from templates
	Rebus::Item * rebus_item;
	bool rebus_checked;

	//std::string dir_old;


	int spam_score;


	PluginData plugin_data;

	// -------------------

	Session();
	void Clear();
	bool operator==(const Session & s) const;
	bool operator<(const Session & s) const;
	void DecTimer(int & timer);
};




#endif

