/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucoresessionmanager
#define headerfilecmslucoresessionmanager

#include <set>
#include <ctime>

#include "sessioncontainer.h"
#include "config.h"
#include "request.h"
#include "lastcontainer.h"
#include "system.h"



class SessionManager
{
	Config * config;
	Request * request;
	System * system;

	SessionContainer session_tab;

	bool IsSession(long s);
	
	long CreateSessionId();
	void CreateTemporarySession();
	void CreateSession();
	bool SetSessionFromCookie(const std::string & cookie);
	int session_checker;

public:

	SessionManager();

	void SetRequest(Request * prequest);
	void SetConfig(Config * pconfig);
	void SetSystem(System * psystem);
	void SetLastContainer(LastContainer * plast_container);

	void SetSession();
	void DeleteAllPluginsData();
	void DeleteOldSessions();

	void LoadSessions();
	void SaveSessions();

	SessionContainer::Iterator SessionBegin();
	SessionContainer::Iterator SessionEnd();
};


#endif
