/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecmslucontentcp
#define headerfilecmslucontentcp

#include "functionbase.h"



namespace Fun
{


class Cp : public FunctionBase
{
public:

	Cp();

private:

	// !! wywalic przedrostki cp_ Cp

	Item cp_temp;
	DbItemQuery cp_iq;
	bool cp_remove_defaults;
	bool cp_preserve_attr;
	long cp_new_user;
	long cp_new_group;

	std::wstring mv_dir;
	std::wstring mv_file;
	std::wstring mv_new_path;
	long mv_dir_id;

	bool CpCheckAccessFrom();
	bool CheckAccessTo(long dir_id);
	bool ParseDir(long & dir_id, std::wstring & dir, std::wstring & file);
	void CpAuth(Item & item);
	void CpSetNewAttributes(Item & item);
	void CpItem(Item & item, long dst_dir_id);
	void CpPrepare();
	void CpFilesInDir(const Item & dir, long dst_dir_id);
	void CpContentOfDir(const Item & item, long dst_dir_id);
	long CpDir(const Item & item, long dst_dir_id);
	bool IsTheSameFile(const Item & item);
	void CpItemCheck(Item & item, bool redirect = true);
	void CpContentOfDirCheck(const Item & item, bool redirect = true);
	void CpDirCheck(const Item & item, bool redirect = true);
	void MakePost();
	void MakeGet();

};


} // namespace

#endif
