/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "functionbase.h"
#include "functions.h"



FunctionBase::FunctionBase()
{
	id = -1;

	fun.user_id    = -1;
	fun.group_id   = -1;
	fun.privileges = 0755;
	fun.parent_id  = -1; // !! temporarily doesn't matter
	fun.id         = -1;
	fun.type       = Item::file;
}



void FunctionBase::SetConfig(Config * pconfig)
{
	config = pconfig;
}


void FunctionBase::SetRequest(Request * prequest)
{
	request = prequest;
}


void FunctionBase::SetDb(Db * pdb)
{
	db = pdb;
}


void FunctionBase::SetSystem(System * psystem)
{
	system = psystem;
}


void FunctionBase::SetFunctions(Functions * pfunctions)
{
	functions = pfunctions;
}


void FunctionBase::SetTemplates(Templates * ptemplates)
{
	templates = ptemplates;
}

void FunctionBase::SetNotify(Notify * pnotify)
{
	notify = pnotify;
}


void FunctionBase::Init()
{
	// this method is called only once at the beginning
	// when winix starts
}


bool FunctionBase::HasAccess()
{
	// true by default
	return true;
}


void FunctionBase::Clear()
{
	// this method is called at the end of a request
	// you can clear your variables
}


void FunctionBase::MakePost()
{
	// do nothing by default
}


void FunctionBase::MakeGet()
{
	// do nothing by default
}




