/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_createticket
#define headerfile_winix_plugins_ticket_createticket

#include "tdb.h"
#include "functions/functionbase.h"
#include "ticketinfo.h"


namespace Ticket
{


class CreateTicket : public FunctionBase
{
public:

	CreateTicket();
	void SetTDb(TDb * ptdb);
	void SetTicketInfo(TicketInfo * pinfo);

	void Clear();
	bool HasAccess(bool check_root);
	bool HasAccess();
	void MakePost();
	void MakeGet();

private:

	void AddTicket();
	void LogAndRedirect();

	TDb * tdb;
	TicketInfo * ticket_info;
};


} // namespace

#endif
