/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_editticket
#define headerfile_winix_plugins_ticket_editticket

#include "tdb.h"
#include "ticket.h"
#include "ticketinfo.h"
#include "functions/functionbase.h"


namespace Ticket
{


class EditTicket : public FunctionBase
{
public:

	EditTicket();
	void SetTDb(TDb * ptdb);
	void SetTicketInfo(TicketInfo * pinfo);

	void Clear();
	bool HasAccess();
	void MakePost();
	void MakeGet();

private:

	void GetFirstItem(Item & item);
	void ModifyTicket();
	void ModifyLastDir();
	void ModifyFirstItem();
	void LogAndRedirect();

	TDb * tdb;
	TicketInfo * ticket_info;
	std::vector<Item> item_tab;
};


} // namespace

#endif
