/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_funticket
#define headerfile_winix_plugins_ticket_funticket

#include "tdb.h"
#include "ticketinfo.h"
#include "core/item.h"
#include "functions/functionbase.h"


namespace Ticket
{


class FunTicket : public FunctionBase
{
public:

	FunTicket();
	void SetTDb(TDb * ptdb);
	void SetTicketInfo(TicketInfo * pinfo);

	void Clear();
	bool HasAccess();
	void MakeGet();

private:

	TDb * tdb;
	TicketInfo * ticket_info;
	std::vector<Item*> child_tab;
	std::vector<long> id_tab;

	struct SortByDate
	{
		FunTicket * fun_ticket;
		SortByDate(FunTicket * f) : fun_ticket(f) {}
		bool operator()(const Item * item1, const Item * item2);
	};

	void SelectTickets();
	void SortDirs();
	void PageDirs();
	void CreateIdTab();

};


} // namespace

#endif
