/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_ticket
#define headerfile_winix_plugins_ticket_ticket

#include <vector>



namespace Ticket
{

struct Ticket
{
	struct TicketParam
	{
		int param;
		int value;

		TicketParam()
		{
			param = value = 0;
		}
	};

	long dir_id;
	std::vector<TicketParam> par_tab;
	
	// auxiliary object used during sorting
	unsigned long sort_id;

	void Clear()
	{
		dir_id = -1;
		par_tab.clear();
		sort_id = 0;
	}


	Ticket()
	{
		Clear();
	}
};


} // namespace


#endif
