/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "templates.h"
#include "../core/request.h"
#include "../core/misc.h"




namespace TemplatesFunctions
{



void user_logged(Info & i)
{
	i.res = request->session->puser != 0;
}


void user_name(Info & i)
{
	if( !request->session->puser )
		return;
	
	HtmlEscape(i.out, request->session->puser->name);
}


void user_is_in_group(Info & i)
{
	long gid = system->groups.GetGroupId(i.par);

	if( !request->session->puser || gid == -1 )
		return;

	i.res = request->session->puser->IsMemberOf(gid);
}



void user_super_user(Info & i)
{
	if( request->session->puser && request->session->puser->super_user )
		i.res = true;
}


void user_can_use_html(Info & i)
{
	if( !request->session->puser )
		i.res = false;
	else
		i.res = system->CanUseHtml(request->session->puser->id);
}


void user_can_use_bbcode(Info & i)
{
	if( !request->session->puser )
		i.res = false;
	else
		i.res = system->CanUseBBCode(request->session->puser->id);
}


void user_can_use_raw(Info & i)
{
	if( !request->session->puser )
		i.res = false;
	else
		i.res = system->CanUseRaw(request->session->puser->id);
}



} // namespace TemplatesFunctions



