/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "templatesnotify.h"
#include "../core/notify.h"



namespace TemplatesNotifyFunctions
{


void notify_item_added(Info & i)
{
	i.res = (notify_msg->notify_code & WINIX_NOTIFY_ITEM_ADD) != 0;
}



void notify_item_edited(Info & i)
{
	i.res = (notify_msg->notify_code & WINIX_NOTIFY_ITEM_EDIT) != 0;
}



void notify_item_deleted(Info & i)
{
	i.res = (notify_msg->notify_code & WINIX_NOTIFY_ITEM_DELETE) != 0;
}



void notify_dir_added(Info & i)
{
	i.res = (notify_msg->notify_code & WINIX_NOTIFY_DIR_ADD) != 0;
}



void notify_to(Info & i)
{
	i.out << notify_msg->email;	
}


void notify_mount_type_is_thread(Info & i)
{
	i.res = notify_msg->current_mount_type == mount_type_thread;
}


void notify_mount_type_is_ticket(Info & i)
{
	i.res = notify_msg->current_mount_type == mount_type_ticket;
}


void notify_mount_type_is_cms(Info & i)
{
	i.res = notify_msg->current_mount_type == mount_type_cms;
}


void notify_doc_base_url(Info & i)
{
	i.out << notify_msg->doc_base_url;
}


void notify_item_dir(Info & i)
{
	i.out << notify_msg->item_dir;	
}



void notify_item_link(Info & i)
{
	i.out << notify_msg->item_link;
}




} // namespace TemplatesNotifyFunctions



